      PROGRAM RGRID
C
C  GENERATES RECTANGULAR GRID (NHE X NVE) WITH SQUARE ELEMENTS
C            NODE NUMBER ALWAYS STARTS AT (0,0)
C
      DIMENSION ILBN(200),IUBN(200)
c
c  Open file for output of results
c
      open(6,file='rgrid.out',status='unknown',err=888)
C
C   ZERO ARRAYS
C
      DO 5 I=1,200
      ILBN(I)=0
      IUBN(I)=0
    5 CONTINUE
C
C    SET THE NO. OF HORIZ. ELEMENTS
C    SET THE NO. OF VERT. ELEMENTS
C
C     NHE=45
C     NVE=180
      NHE=30
      NVE=60
      DELTA=1.0
C
C   SET THE DIRECTION OF LOWER BOUNDARY DISPL. ( 1=LONG. WAVE , 2=TRANS. WAVE ) 
C
      IDIRLB=1
C
C    INITIALIZE NODE NUMBERING PARAMETERS
C
      H=-DELTA
      Z=0.0
      IND=0
C
C  CALCULATE THE  NODE POINT COORDINATES
C
      VCUB=NVE
      NVEP1=NVE+1
      NHEP1=NHE+1
      DO 30 IZL=1,NVEP1
      H=-DELTA
      DO 20 IHL=1,NHEP1
      IND=IND+1
      H=H+DELTA
      IH=0
      IZ=0
      IF((Z.EQ.0.0).OR.(Z.EQ.VCUB))IH=1 
      IF((Z.EQ.0.0).OR.(Z.EQ.VCUB))IZ=1 
      WRITE(6,10)IND,IH,IZ,H,Z
   10 FORMAT(I6,2I3,2F12.5)
      IF(IHL.EQ.1)ILBN(IZL)=IND
      IF(IHL.EQ.NHEP1)IUBN(IZL)=IND
   20 CONTINUE
      Z=Z+DELTA
   30 CONTINUE
C
C  CALCULATE THE NODE NO.S ASSOCIATED WITH EACH ELEMENT
C
C    DEFINE INTIAL PARAMETERS 
C
      IEL=0
      THICK=1.0
      IND1=0
      IND2=1
      IND3=IND2+NHE+1
      IND4=IND1+NHE+1
C
C  CALCULATE TOPOLOGY FOR REMAINING ELEMENTS
C
      DO 60 IVE=1,NVE
      DO 50 IHE=1,NHE
      IEL=IEL+1
      IND1=IND1+1
      IND2=IND2+1
      IND3=IND3+1
      IND4=IND4+1
      WRITE(6,40)IEL,IND1,IND2,IND3,IND4,THICK
   40 FORMAT(5I6,F12.1)
   50 CONTINUE
      IND1=IND1+1
      IND2=IND2+1
      IND3=IND3+1
      IND4=IND4+1
   60 CONTINUE
C
C  WRITE THE LOWER AND UPPER BOUNDARY NODES TO OUTPUT FILE
C
      DO 85 IZL=1,NVEP1
      WRITE(6,80)IUBN(IZL)
   80 FORMAT(I6)
   85 CONTINUE
      DO 75 IZL=1,NVEP1
      WRITE(6,70)ILBN(IZL),IDIRLB
   70 FORMAT(2I6)
   75 CONTINUE
C
  888 STOP
      END 
